#!/bin/sh

# ----------------------------------------------------------------------------------------------------------------------------------------
#	2007-11-02		v0.0.1
#	2008-02-11		v0.0.2
#	2008-02-21		v0.0.3	modify "line struct" , 4 parts
#									log.sh $1 $2 $3
#									$1 : log_type
#									$2 : log name [setup/alarm]?
#									$3 : log value[setup/alarm]?value:NULL
#	2008-05-15		v0.0.4	big operation
#									log.sh $1 $2 $3
#									$1 : log type
#									$2 : obj
#									$3 : value
#	2008-05-16		v0.0.5	rebuild log.data when log.data > MAX_LINE
#	2008-10-13		v0.0.6	remove $log_type and $log_blank from log.data
#	2008-12-08		v0.0.7	fix bug Txmode ; fix bug ODU TxMute
#	2009-01-06		v0.0.8	add dry contact log
#	2009-01-06		v0.0.9	add EthPort log
#	2009-01-16		v0.1.0	add RFloop log
# 	2010-03-04 		v0.1.1 	comment "echo -n $max_line_num $cru_line_num
#-----------------------------------------------------------------------------------------------------------------------------------------

#log(){
#	echo $1 $2
#	sed -i '$i\$1 $2' log.data
#}

max_line_num=`grep -s "MAX_LINE" /home/PDH/log.conf | cut -f2 -d"="`
cru_line_num=`cat /home/PDH/log.data | wc -l`

if [ $cru_line_num -le $max_line_num ]; then
#	echo -n $max_line_num $cru_line_num
#	echo ""
	break
else
	/home/PDH/Delete_log.sh
	echo "Log Has Been Cleared" >> log.data
	exit
fi

obj_name=`grep $2 /home/PDH/log.conf | cut -f1 -d"="`

log_date=`date`
log_blank=" | "
log_type=$1
log_name=$obj_name
log_value=$3

# ------------------------------------- SYS -----------------------------------------------------

# ------------------------------------- IDU -----------------------------------------------------
if [ $2 = 0x0402 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "1+0 mode"`
	elif [ $3 = '1' ]; then
		log_value=`echo "1+1 mode"`
	elif [ $3 = '2' ]; then
		log_value=`echo "2+0 mode"`
	fi
fi

if [ $2 = 0x0419 ]; then
	if [ $3 = '2' ]; then
		log_value=`echo "4E1"`
	elif [ $3 = '3' ]; then
		log_value=`echo "8E1"`
	elif [ $3 = '4' ]; then
		log_value=`echo "16E1"`
	elif [ $3 = '5' ]; then
		log_value=`echo "6E1"`
	elif [ $3 = '6' ]; then
		log_value=`echo "12E1"`
	elif [ $3 = '7' ]; then
		log_value=`echo "24E1"`
	fi
fi

if [ $2 = 0x041C ]; then
	if [ $3 = '2' ]; then
		log_value=`echo "4E1"`
	elif [ $3 = '3' ]; then
		log_value=`echo "8E1"`
	elif [ $3 = '4' ]; then
		log_value=`echo "16E1"`
	elif [ $3 = '5' ]; then
		log_value=`echo "6E1"`
	elif [ $3 = '6' ]; then
		log_value=`echo "12E1"`
	elif [ $3 = '7' ]; then
		log_value=`echo "24E1"`
	fi
fi

if [ $2 = 0x040D ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "West"`
	elif [ $3 = '1' ]; then
		log_value=`echo "East"`
	fi
fi

if [ $2 = 0x040E ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "None"`
	elif [ $3 = '1' ]; then
		log_value=`echo "West"`
	elif [ $3 = '2' ]; then
		log_value=`echo "East"`
	elif [ $3 = '3' ]; then
		log_value=`echo "West and East"`
	fi
fi

if [ $2 = 0x040F ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "HSB"`
	elif [ $3 = '1' ]; then
		log_value=`echo "FD"`
	elif [ $3 = '2' ]; then
		log_value=`echo "None"`
	fi
fi

if [ $2 = 0x0410 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "None"`
	elif [ $3 = '1' ]; then
		log_value=`echo "West"`
	elif [ $3 = '2' ]; then
		log_value=`echo "East"`
	fi
fi

if [ $2 = 0x0411 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "None"`
	elif [ $3 = '1' ]; then
		log_value=`echo "West"`
	elif [ $3 = '2' ]; then
		log_value=`echo "East"`
	fi
fi

if [ $2 = 0x0414 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "OFF"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Analog"`
	elif [ $3 = '2' ]; then
		log_value=`echo "Analog"`
	fi
fi


# ------------------------------------- ODU  ----------------------------------------------------
# West ODU TxPower
if [ $2 = 0x0604 ]; then
	log_value=`echo -n $log_value "dBm"`
fi

# West ODU TxSwitch
if [ $2 = 0x0620 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo -n  "ON"`
	else
		log_value=`echo -n  "OFF"`
	fi

fi

# West ODU RxAlarmLevel
if [ $2 = 0x061F ]; then
	log_value=`echo -n $log_value "dBm"`
fi

# West ODU Rfloop
if [ $2 = 0x0621 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "OFF"`
	else
		log_value=`echo "ON"`
	fi
fi

# East ODU TxPower
if [ $2 = 0x0504 ]; then
	log_value=`echo -n $log_value "dBm`
fi

# East ODU TxSwitch
if [ $2 = 0x0520 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "ON"`
	else
		log_value=`echo "OFF"`
	fi
fi

# East ODU RxAlarmLevel
if [ $2 = 0x051F ]; then
	log_value=`echo -n $log_value "dBm"`
fi

# East ODU Rfloop
if [ $2 = 0x0521 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "OFF"`
	else
		log_value=`echo "ON"`
	fi
fi

# ------------------------------------- Dry Contact  ----------------------------------------------------
if [ $2 = 0x0302 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo -n "NO"`
	else
		log_value=`echo -n "YES"`
	fi
fi

if [ $2 = 0x0305 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo -n "NO"`
	else
		log_value=`echo -n "YES"`
	fi
fi

if [ $2 = 0x0303 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "None"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Loopback"`
	elif [ $3 = '2' ]; then
		log_value=`echo "IDU West Alarm"`
	elif [ $3 = '3' ]; then
		log_value=`echo "IDU East Alarm"`
	elif [ $3 = '4' ]; then
		log_value=`echo "ODU West Alarm"`
	elif [ $3 = '5' ]; then
		log_value=`echo "ODU East Alarm"`
	elif [ $3 = '6' ]; then
		log_value=`echo "Remote West Alarm"`
	elif [ $3 = '7' ]; then
		log_value=`echo "Remote East Alarm"`
	elif [ $3 = '8' ]; then
		log_value=`echo "All"`
	fi
fi

if [ $2 = 0x0306 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "None"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Loopback"`
	elif [ $3 = '2' ]; then
		log_value=`echo "IDU West Alarm"`
	elif [ $3 = '3' ]; then
		log_value=`echo "IDU East Alarm"`
	elif [ $3 = '4' ]; then
		log_value=`echo "ODU West Alarm"`
	elif [ $3 = '5' ]; then
		log_value=`echo "ODU East Alarm"`
	elif [ $3 = '6' ]; then
		log_value=`echo "Remote West Alarm"`
	elif [ $3 = '7' ]; then
		log_value=`echo "Remote East Alarm"`
	elif [ $3 = '8' ]; then
		log_value=`echo "All"`
	fi
fi

# ------------------------------------- Ethernet Port  ----------------------------------------------------
if [ $2 = 0x0701 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "10Mbps"`
	elif [ $3 = '1' ]; then
		log_value=`echo "100Mbps"`
	fi
fi

if [ $2 = 0x0702 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Half-Duplex"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Full-Duplex"`
	fi
fi

if [ $2 = 0x0703 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Disable"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Enable"`
	fi
fi

if [ $2 = 0x0704 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "1552 bytes"`
	elif [ $3 = '1' ]; then
		log_value=`echo "1536 bytes"`
	fi
fi

if [ $2 = 0x0705 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Disable"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Enable"`
	fi
fi

if [ $2 = 0x0801 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "10Mbps"`
	elif [ $3 = '1' ]; then
		log_value=`echo "100Mbps"`
	fi
fi

if [ $2 = 0x0802 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Half-Duplex"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Full-Duplex"`
	fi
fi

if [ $2 = 0x0803 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Disable"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Enable"`
	fi
fi

if [ $2 = 0x0804 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "1552 bytes"`
	elif [ $3 = '1' ]; then
		log_value=`echo "1536 bytes"`
	fi
fi

if [ $2 = 0x0805 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Disable"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Enable"`
	fi
fi

if [ $2 = 0x0901 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "10Mbps"`
	elif [ $3 = '1' ]; then
		log_value=`echo "100Mbps"`
	fi
fi

if [ $2 = 0x0902 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Half-Duplex"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Full-Duplex"`
	fi
fi

if [ $2 = 0x0903 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Disable"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Enable"`
	fi
fi

if [ $2 = 0x0904 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "1552 bytes"`
	elif [ $3 = '1' ]; then
		log_value=`echo "1536 bytes"`
	fi
fi

if [ $2 = 0x0905 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Disable"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Enable"`
	fi
fi

if [ $2 = 0x0B01 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "10Mbps"`
	elif [ $3 = '1' ]; then
		log_value=`echo "100Mbps"`
	fi
fi

if [ $2 = 0x0B02 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Half-Duplex"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Full-Duplex"`
	fi
fi

if [ $2 = 0x0B03 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Disable"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Enable"`
	fi
fi

if [ $2 = 0x0B04 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "1552 bytes"`
	elif [ $3 = '1' ]; then
		log_value=`echo "1536 bytes"`
	fi
fi

if [ $2 = 0x0B05 ]; then
	if [ $3 = '0' ]; then
		log_value=`echo "Disable"`
	elif [ $3 = '1' ]; then
		log_value=`echo "Enable"`
	fi
fi


#log_line=`echo -n $log_type     $log_blank     $log_date     $log_blank     $log_name $log_value`
log_line=`echo -n $log_date     $log_blank     $log_name   $log_value`

echo $log_line >> /home/PDH/log.data

