#!/bin/sh

# --------------------------------------------------------------------------------------------------------------
#	2007-11-01		v0.0.1
#						Product Name
#						Product Description
#						Product Location
#						Soft Ver
#						IDU Pn
#						IDU Sn
#						IDU Time Tick			unsure format
#						IDU RTC					linux 'date' format
#						IDU IP					bug ?
#						IDU MAC
#						IDU MASK
#						IDU GATE					no support
#						IDU TRAPHOST1
#						IDU TRAPHOST2
#						IDU TRAPHOST3
#	2008-01-24		v0.0.2
#						IDU GATE
#	2008-03-17		v0.0.3
#						return OBJ_SYS_*
#	2008-04-14		v0.0.4
#						Software in SW_VER.conf instead of PDH_IDU.conf
#	2008-04-22		v0.0.5
#						Add OS Version
#	2008-05-08		v0.0.6
#						modify query RTC , modify query uptime
#	2008-05-20		v0.0.7
#						del tmp_date_file after query_RTC_sys
#	2008-12-30		v0.0.8
#						add obj_sys_uptime
#	2009-02-09		v0.0.9
#						no use OBJ_SYS_IDU_UPTIME(0x0117) any more
#	2009-02-11		v0.1.0
#						add query snmp community
#	2009-04-29		v0.1.1		modify path of snmpd.conf
#						query snmp : mail , web , trapport
#	2009-08-20		v0.1.2		query web user name , query web user password.
#	2009-09-17		v0.1.3		check web user name.
# 	2010-01-20 		v014 		query arm-id , query fpga_id , query address( short.ssn )
# 	2010-01-22 		v015 		query license file exist , query license match , 
# 	2010-03-01 		V016 		echo license file
# 	2010-03-10 		V017 		list license file at /home/config/
# 	2010-09-10 		V018 		surport oem export
#----------------------------------------------------------------------------------------------------------------

#
# Display what is the shell
#
VER=017
#echo " Query Sys Shell Versin $VER"

#
# Define Object
#
OBJ_SYS_PRODUCT_NAME=0x0101
OBJ_SYS_PRODUCT_DESCRIPTION=0x0102
OBJ_SYS_LOCATION=0x0103
OBJ_SYS_SOFT_VER=0x0104
OBJ_SYS_IDU_PN=0x0107
OBJ_SYS_IDU_SN=0x0108
OBJ_SYS_TEMP=0x0109
OBJ_SYS_IDU_TICK=0x010A
OBJ_SYS_RTC=0x010B
OBJ_SYS_IP=0x010F
OBJ_SYS_MAC=0x010E
OBJ_SYS_MASK=0x0110
OBJ_SYS_GATE=0x0111
OBJ_SYS_TRAPHOST1=0x0112
OBJ_SYS_TRAPHOST2=0x0113
OBJ_SYS_TRAPHOST3=0x0114
OBJ_SYS_OSVER=0x0116
OBJ_SYS_IDU_UPTIME=0x0117
OBJ_SYS_ROCOMMUNITY=0x0119
OBJ_SYS_RWCOMMUNITY=0x011A
OBJ_SYS_SNMP_MAIL=0x011B
OBJ_SYS_SNMP_WEB=0x011C
OBJ_SYS_SNMP_TRAPPORT=0x011D
OBJ_SYS_WEB_USERNAME=0x011E
OBJ_SYS_WEB_PASSWORD=0x011F
OBJ_SYS_WEB_LOG_PASSWORD_CHKSUM=0x0120			# with arg = password to be checked.
OBJ_SYS_WEB_LOG_NAME_CHKSUM=0x0129			# with arg = name to be checked.
OBJ_LIC_ARM_ID=0x0C01
OBJ_LIC_FPGA_ID=0x0C02
OBJ_LIC_ADDR=0x0C03
OBJ_LIC_EXIST=0x0C06
OBJ_LIC_MATCH=0x0C07
OBJ_LIC_ECHO=0x0C0F
OBJ_LIC_LIST=0x0C10


# Define path of web user and password
web_password="/home/config"

#
# Query Sys Product Name
#
if [ $1 = $OBJ_SYS_PRODUCT_NAME ]; then
	vv=`grep "PRODUCT_NAME_SYS=" /home/PDH/PDH_IDU.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys Product Description
#
if [ $1 = $OBJ_SYS_PRODUCT_DESCRIPTION ]; then
	vv=`grep "PRODUCT_DESCRIPTION_SYS=" /home/config/PDH_IDU.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys Location
#
if [ $1 = $OBJ_SYS_LOCATION ]; then
	vv=`grep "LOCATION_SYS=" /home/PDH/PDH_IDU.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys SoftWare Version
#
if [ $1 = $OBJ_SYS_SOFT_VER ]; then
	vv=`grep "SOFT_VER_SYS=" /home/PDH/SW_VER.conf | cut -f2 -d"="`
	vv2=`grep "REV_VER_SYS=" /home/PDH/SW_VER.conf | cut -f2 -d"="`
	echo -n $1 $vv"_"$vv2
	echo ""	
fi

#
# Query IDU PN
#
if [ $1 = $OBJ_SYS_IDU_PN ]; then
	vv=`grep "IDU_PN_SYS=" /home/PDH/PDH_IDU.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query IDU SN
#
if [ $1 = $OBJ_SYS_IDU_SN ]; then
	vv=`grep "IDU_SN_SYS=" /home/PDH/PDH_IDU.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query IDU TickTime
#
if [ $1 = $OBJ_SYS_IDU_TICK ]; then
#	vv=`uptime`
#	echo -n $1 $vv
#	echo ""
	vv=`uptime | grep -s "up" | cut -f2 -d"p" | cut -f1 -d"l"`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys RTC
#
if [ $1 = $OBJ_SYS_RTC ]; then
#	vv=`date`
#	echo -n $1 $vv
#	echo ""
	date > /tmp/tmp_date_file
	sed -i -e "s|UTC| |g" /tmp/tmp_date_file
	vv=`cat /tmp/tmp_date_file`
	echo -n $1 $vv
	echo ""
	rm -f /tmp/tmp_date_file
fi

#
# Query Sys IP
#
if [ $1 = $OBJ_SYS_IP ]; then
	vv=`ifconfig | grep "inet addr:" | cut -f2 -d":" | cut -f1 -d" " | head -c 15`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys MAC
#
if [ $1 = $OBJ_SYS_MAC ]; then
	vv=`ifconfig | grep "HWaddr" | cut -f11 -d" " | head -c 18           #| cut -f1 -d" " | cut -f1 -d" "`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys Mask
#
if [ $1 = $OBJ_SYS_MASK ]; then
	vv=`ifconfig | grep "Mask" | cut -f4 -d":"`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys Gate
#
if [ $1 = $OBJ_SYS_GATE ]; then
        gate=`grep -s "gateway" /etc/network/interfaces | cut -f2 -d" "`
        echo $1 $gate
		  echo ""
fi


#
# Query Sys Trap Host 1
#
if [ $1 = $OBJ_SYS_TRAPHOST1 ]; then
	vv=`grep "TRAPHOST1_SYS=" /home/PDH/PDH_IDU.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys Trap Host 2
#
if [ $1 = $OBJ_SYS_TRAPHOST2 ]; then
	vv=`grep "TRAPHOST2_SYS=" /home/PDH/PDH_IDU.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys Trap Host 3
#
if [ $1 = $OBJ_SYS_TRAPHOST3 ]; then
	vv=`grep "TRAPHOST3_SYS=" /home/PDH/PDH_IDU.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query Sys OS Version
#
if [ $1 = $OBJ_SYS_OSVER ]; then
	vv=`grep "OS_VER_SYS=" /home/PDH/OS_VER.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query IDU uptime
#
if [ $1 = $OBJ_SYS_IDU_UPTIME ]; then
	vv=`grep "AUTOSAVE_IDU_UPTIME=" /home/PDH/autosave.data | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

#
# Query SNMP rocommunity
#
if [ $1 = $OBJ_SYS_ROCOMMUNITY ]; then
	vv=`grep "rocommunity" /home/config/snmpd.conf | tail -n 1 | cut -f3 -d" "`
	echo -n $1 $vv
	echo ""
fi

#
# Query SNMP rwcommunity
#
if [ $1 = $OBJ_SYS_RWCOMMUNITY ]; then
	vv=`grep "rwcommunity" /home/config/snmpd.conf | tail -n 1 | cut -f3 -d" "`
	echo -n $1 $vv
	echo ""
fi

# Query Web Username
if [ $1 = $OBJ_SYS_WEB_USERNAME ]; then
	vv=`grep "user" $web_password/password.conf | cut -f2 -d":"`
	echo -n $1 $vv
	echo ""
fi

# Query Web Password
if [ $1 = $OBJ_SYS_WEB_PASSWORD ]; then
	vv=`grep "password" $web_password/password.conf | cut -f2 -d":"`
	echo -n $1 $vv
	echo ""
fi

# Web Loging Chk Password
if [ $1 = $OBJ_SYS_WEB_LOG_PASSWORD_CHKSUM ]; then
	# -------------------- md5 ver ----------------------------------
	#vv=`grep "password" $web_password/password.conf | cut -f2 -d":"`
	##echo $vv
	#kk=`/home/SDH/bin/password $2 | grep -s "Digest" | cut -f2 -d:"`
	##echo $kk
	#if [ $vv = $kk ]; then
	#	echo "0"
	#else
	#	echo "1"
	#fi
	# ---------------------------------------------------------------
	# -------------------- clear-text ver ---------------------------
	vv=`grep "password" $web_password/password.conf | cut -f2 -d":"`
	if [ $vv = $2 ]; then
		echo "0"
	else
		echo "1"
	fi
	# ---------------------------------------------------------------	
fi

# Web Loging Chk Name
if [ $1 = $OBJ_SYS_WEB_LOG_NAME_CHKSUM ]; then
	# -------------------- clear-text ver ---------------------------
	vv=`grep "user" $web_password/password.conf | cut -f2 -d":"`
	if [ $vv = $2 ]; then
		echo "0"
	else
		echo "1"
	fi
	# ---------------------------------------------------------------	
fi


# Query SNMP Email
if [ $1 = $OBJ_SYS_SNMP_MAIL ]; then
	vv=`grep "snmp_email" /home/config/snmp_misc.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

# Query SNMP Web
if [ $1 = $OBJ_SYS_SNMP_WEB ]; then
	vv=`grep "snmp_web" /home/config/snmp_misc.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

# Query SNMP Trapport
if [ $1 = $OBJ_SYS_SNMP_TRAPPORT ]; then
	vv=`grep "snmp_trapport" /home/config/snmp_misc.conf | cut -f2 -d"="`
	echo -n $1 $vv
	echo ""
fi

# Query License ARM-ID
if [ $1 = $OBJ_LIC_ARM_ID ]; then
	if [ -f /home/config/SerNum.conf ]; then
		vv=`grep "ARM_SN=" /home/config/SerNum.conf | cut -f2 -d"="`
		echo -n $1 $vv
		echo ""
	else
		echo -n $1
		echo ""
	fi
fi

# Query License FPGA-ID
if [ $1 = $OBJ_LIC_FPGA_ID ]; then
	if [ -f /home/config/SerNum.conf ]; then
		vv=`grep "FPGA_SN=" /home/config/SerNum.conf | cut -f2 -d"="`
		echo -n $1 $vv
		echo ""
	else
		echo -n $1
		echo ""
	fi
fi

# Query License Addr.
if [ $1 = $OBJ_LIC_ADDR ]; then
	if [ -f /home/config/short.ssn ]; then
		vv=`grep "SSNADDR=" /home/config/short.ssn | cut -f2 -d"="`
		echo -n $1 $vv
		echo ""
	else
		echo -n $1
		echo ""
	fi
fi

# Query License license file exist
if [ $1 = $OBJ_LIC_EXIST ]; then
	if [ -f /home/config/license.dat ]; then
		echo $1 "0"
	else
		echo $1 "1"
	fi
fi

# Query License lincese match
if [ $1 = $OBJ_LIC_MATCH ]; then
	if [ -f /home/config/license.dat ]; then
		LIC_FILE_FORMAT_VER=`grep "LICVER" /home/config/license.dat | cut -f2 -d"="`
		case $LIC_FILE_FORMAT_VER in
			001)
				LIC_FILE_ARM_ID=`grep "ARM_ID" /home/config/license.dat | cut -f2 -d"="`
				vv=`grep "ARM_SN=" /home/config/SerNum.conf | cut -f2 -d"="` # assume SerNum.conf exist
				if [ $LIC_FILE_ARM_ID = $vv ]; then
					echo $1 "0"
				else
					echo $1 "1"
				fi
				;;
			*)
				# error
				;;
		esac
	else
		break # error
	fi
fi

# Echo License file
if [ $1 = $OBJ_LIC_ECHO ]; then
	if [ -f /home/config/license.dat ]; then
		cat /home/config/license.dat
	else
		echo "License does not exist"
		break
	fi
fi

# List License file at /home/config/
if [ $1 = $OBJ_LIC_LIST ]; then
	# keep current pwd
	mypath=`pwd`
	# enter /home/config/
	cd /home/config/
	# list *.lic
	ls -1 *.lic
	# leave /home/config and enter previous
	cd $mypath
fi



